Namespaces
Variants
Views
Actions

std::uncaught_exception, std::uncaught_exceptions

From cppreference.com
< cpp‎ | error
 
 
Diagnostics library
Exception handling
uncaught_exceptionuncaught_exceptions
(until C++20)(C++17)
Exception handling failures
(until C++17)
(until C++17)
(C++11)(until C++17)
(until C++17)
Error codes
Error codes
 
Defined in header <exception>
(1)
bool uncaught_exception() throw();
(until C++11)
bool uncaught_exception() noexcept;
(since C++11)
(deprecated in C++17)
(removed in C++20)
int uncaught_exceptions() noexcept;
(2) (since C++17)
1) Detects if the current thread has a live exception object, that is, an exception has been thrown or rethrown and not yet entered a matching catch clause, std::terminate or std::unexpected. In other words, std::uncaught_exception detects if stack unwinding is currently in progress.
2) Detects how many exceptions in the current thread have been thrown or rethrown and not yet entered their matching catch clauses.

Sometimes it's safe to throw an exception even while std::uncaught_exception() == true. For example, if stack unwinding causes an object to be destructed, the destructor for that object could run code that throws an exception as long as the exception is caught by some catch block before escaping the destructor.

Contents

[edit] Parameters

(none)

[edit] Return value

1) true if stack unwinding is currently in progress in this thread, false otherwise.
2) The number of uncaught exception objects in the current thread.

[edit] Notes

An example where int-returning uncaught_exceptions is used is the boost.log library: the expression BOOST_LOG(logger) << foo(); first creates a guard object and records the number of uncaught exceptions in its constructor. The output is performed by the guard object's destructor unless foo() throws (in which case the number of uncaught exceptions in the destructor is greater than what the constructor observed).

std::experimental::scope_fail and std::experimental::scope_success in LFTS v3 rely on the functionality of uncaught_exceptions, because their destructors need to do different things that depend on whether is called during stack unwinding.

Feature-test macro
__cpp_lib_uncaught_exceptions

[edit] Example

#include <iostream>
#include <exception>
#include <stdexcept>
 
struct Foo
{
    int count = std::uncaught_exceptions();
 
    ~Foo()
    {
        std::cout << (count == std::uncaught_exceptions()
            ? "~Foo() called normally\n"
            : "~Foo() called during stack unwinding\n");
    }
};
 
int main()
{
    Foo f;
 
    try
    {
        Foo f;
        std::cout << "Exception thrown\n";
        throw std::runtime_error("test exception");
    }
    catch (const std::exception& e)
    {
        std::cout << "Exception caught: " << e.what() << '\n';
    }
}

Possible output:

Exception thrown
~Foo() called during stack unwinding
Exception caught: test exception
~Foo() called normally

[edit] Defect reports

The following behavior-changing defect reports were applied retroactively to previously published C++ standards.

DR Applied to Behavior as published Correct behavior
LWG 70 C++98 the exception specification of uncaught_exception() was missing specified as throw()

[edit] See also

function called when exception handling fails
(function) [edit]
shared pointer type for handling exception objects
(typedef) [edit]
captures the current exception in a std::exception_ptr
(function) [edit]

[edit] External links